﻿/// <reference path="lib/jquery-3.2.0.min.js" />
(function (path, window, document, pageInit) {

    //path bug fixed
    if (path.length && path.substr(path.length - 1, 1) != "/") {
        path = path.substr(0, path.lastIndexOf("/") + 1);
    }

    //AORUS: 1.12.3
    //GIGABYTE: 1.12.4
    var $$ = window.jQuery;
    var gs = window.gs = {
        path: path,
        resolvePath: function (str) {
            if (str && str.length > 0) {
                if (str.substr(0, 5) == "http:" || str.substr(0, 6) == "https:" || str.substr(0, 2) == "//") {
                    return str;
                }else if(str.substr(0, 1) == "/"){
                    str = str.substr(1);
                }
            }
            return path + str;
        },
        resolveAttrPath: function (selector, attr) {
            var el = $$(selector);

            el.find('[' + attr + ']').each(function () {
                $(this).attr(attr, gs.resolvePath($(this).attr(attr)));
            });
        },        
        addCSSlink: function (src) {
            var cssdom = document.createElement("link");
            cssdom.href = src;
            cssdom.rel = "stylesheet";
            cssdom.type = "text/css";
            $$("head").append(cssdom);
        },
        addScript: function (src) {
            var scriptdom = document.createElement("script");
            scriptdom.type = "text/javascript";
            scriptdom.src = src;
            $$("head").append(scriptdom);
        },
    };
                                
    $.ajax({
        url: 'main.html',
        dataType: 'html',
        success: function (data) {
            var div = $$('<div>'),
                html = data,
                iframe = $$('#iframe_kf, #kf-iframe'),
                elem;

            if (~(html.indexOf('<body')) && ~(html.indexOf('<\/body>'))) {
                html = /\<body[^\>]*>([\s\S]*)(?:<\/body>)/.exec(data)[1];
            }

            div.html(html);
            gs.resolveAttrPath(div, 'src');
            gs.resolveAttrPath(div, 'href');

            elem = div.children();

            if (iframe.length) {
                iframe.after(elem);
            } else {
                $('body').append(elem);
            }

            pageInit.call(window, gs);

            iframe.hide();
        }
    });

})(window.location.pathname, window = (window.top || window), window.document, _GS_INIT);