﻿/// <reference path="lib/jquery-1.12.4.js" />
/// <reference path="loader.js" />
var _GS_INIT = function () {
    var window = this,
        document = window.document,
        gs = window.gs,
        $ = window.jQuery,
        path = "";
    
    if (gs) {
        path = gs.path;
        //手動加上外層的css或js                                 
        gs.addCSSlink(gs.resolvePath('css/fix.css'));
        gs.addCSSlink(gs.resolvePath('css/style.css'));
        gs.addScript(gs.resolvePath('js/spectrum.js'));

        //修正gallery的路徑
        gs.resolveAttrPath('#gallery', 'data-src');
    }

    //scrollTop fn
    (function (window) { var i, n, t; i = "pageYOffset" in window; n = { scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }; for (t in n) window[t] = function (t, r) { var u = r === n.scrollTop; return function (n) { if (typeof n == "undefined") return i ? window[r] : document.documentElement[t] || document.body[t] || 0; window.scrollTo(u ? window.scrollLeft() : n, u ? n : window.scrollTop()) } }(t, n[t]) })(window);


    init();

    function init() {
        $.fn.spectrum = window.jQuery.fn.spectrum;

        gallery();
        initRDKB();
    }


    function gallery() {
        var elem = $('#gallery');
        var content = $('#gallery-content', elem);
        var btnPrev = $('#gallery-prev', elem);
        var btnNext = $('#gallery-next', elem);
        var btnClose = $('#gallery-close', elem);

        var index = 0;
        var list = [];
        var len;
        var item = elem.find('.gallery-box[data-type]');

        //修正路徑
        item.each(function (a, b) {
            var self = $(this);
            var img = self.find('img');
        
            //img.prop('src', path + img.attr('src'));
            //b.href = path + self.attr('href');
            //
            //var dsrc = self.attr('data-src');
            //self.attr('data-src', path + dsrc);
        
            add(this);
        });

        btnPrev.on('click', prev);
        btnNext.on('click', next);
        btnClose.on('click', close);

        elem.on('click', '.gallery-cover', function (e) {
            e.preventDefault();
            close();
        });
        elem.on('click', '.gallery-main', function (e) {
            e.stopPropagation(); self
        });

        function add(dom) {
            var self = $(dom);
            var type = self.attr('data-type');
            var src = self.attr('data-src');
            var i;

            if (type) {

                var data = {
                    elem: self,
                    type: type,
                    src: src
                };

                if (type == "iframe") {

                    var width = self.attr('data-width');
                    var height = self.attr('data-height');

                    data.width = width;
                    data.height = height;
                }

                i = list.push(data);

                self.on('click', function (e) {
                    if (window.innerWidth > 960) {
                        e.preventDefault();
                        to(i - 1);
                    }
                });
            }

            len = list.length;
        }
        function open() {
            elem.addClass("show");
        }
        function close() {
            elem.removeClass("show");
        }
        function prev() {
            if (len <= 1) {
                return;
            }

            if (index == 0) {
                to(len - 1);
            } else {
                to(index - 1);
            }
        }
        function next() {
            if (len <= 1) {
                return;
            }

            if (index == len - 1) {
                to(0);
            } else {
                to(index + 1);
            }
        }
        function to(n) {
            if (!n && !list[n]) {
                return;
            }

            var dat = list[n];

            index = n;
            content.html('');
            open();

            if (dat.type == 'image') {
                content.append('<img class="gallery-show" src="' + dat.src + '"/>');
            }

            if (dat.type == 'iframe') {
                var frame = $('<iframe class="gallery-show" src="' + dat.src + '" frameborder="0" scrolling="no" width="' + dat.width + '" height="' + dat.height + '"/>');

                content.append(frame);
            }
        }
    }

    function initRDKB() {

        var kbef;
        var ef;
        var sto;
        var anidom;
        var inp_color;
        var _wok = false;
        var changecolorCB;
        var ag = new AntiGhost(rgbkmap);

        var cmap = {};
        for (var p in rgbkmap) {
            cmap[Key.KeyList[p]] = rgbkmap[p];
        }


        function clear() {

        }
        function bCCB(name, FN) {
            change(name);
            changecolorCB = FN;
        }
        function init() {
            kbef = $("#kb-ef");
            inp_color = $("#rgb_color_group2");
            ef = "";
            _enable = false;

            initComponent();
            initEvent();
        };

        function initComponent() {

            //$.each(rgbkmap, function (key, group) {
            //    $.each(group, function (index, co) {
            //        co[0] -= 90;
            //        co[1] -= 62;
            //    });
            //});


            ag.init($('#vkb')[0]);

            $.each(rgbkmap, function (keyname) {
                ag.addKey(Key.KeyList[keyname]);
            });


            $(".btn-rgbicon").each(function () {

                var $self = $(this);
                //var title = $self.find(".btn-rgbbtntitle");
                //var text = $self.find(".rgb_titletext");
                //var w = title.width();
                //title.css("left", 31 - w / 2)

                $self.hover(function () {
                    $self.addClass("hover");
                }, function () {
                    $self.removeClass("hover");
                });

            });
        }

        function initEvent() {
            //ef_static(true);
            wave("left");
            //marquee();
            singlecolor();
            breathcolor();
            rain();
            waveonkey();
            //gametype();


            inp_color.change(function () {

                if (changecolorCB) {
                    changecolorCB($(this).val());
                }

            });

            var defaultColor = "#ff6c00";
            inp_color.val(defaultColor).spectrum({
                disabled: true,
                color: defaultColor,
                clickoutFiresChange: true,
                appendTo: document.body
            });
        }

        function stop() {
            if (sto) clearTimeout(sto);
            _wok = false;
        }
        function ef_static(bool) {
            var dom = $("#ef0-default");

            $("#btn-default").on("click", function () {
                on();
            });

            function on() {
                change("default");
            }

            if (bool) on();
        }
        function change(name, newdom) {
            var b;

            b = ef != name;

            stop();
            kbef.removeClass();
            kbef.addClass(name);

            ef = name;

            return b;
        }

        function wave(direct) {
            var time = { v: 2500, h: 1000 };
            var direction = true;
            var lr = $("#ef1-lr-img")[0];
            var td = $("#ef1-td-img")[0];
            var y = x = 0;
            var fps = 1000 / 60;
            var btn = $("#rgbbtn_wave");

            function px() {
                var d;
                var m = 1240;
                d = m / time.h * fps;
                x = x + d * (direction ? 1 : -1);
                x = x % m;
                return -x + "px 0";
            }
            function py() {
                var d;
                var m = 713;
                d = m / time.v * fps;
                y = y + d * (direction ? 1 : -1);
                y = y % m;
                return "0 " + -y + "px";
            }

            function bpx() {
                lr.style.backgroundPosition = px();
                stop();
                sto = setTimeout(bpx, fps);
            }
            function bpy() {
                td.style.backgroundPosition = py();
                stop();
                sto = setTimeout(bpy, fps);
            }
            function go_x(d) {
                direction = d;
                change("wave_lr");
                bpx();
            }
            function go_y(d) {
                direction = d;
                change("wave_td");
                bpy();
            }
            btn.click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                $("#rgbbtn_wavedir_left").addClass("active");
                inp_color.spectrum("disable");

                btn.addClass("active");
                go_x(true);
            });
            $("#rgbbtn_wavedir_left").click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(this).addClass("active").siblings().removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("disable");

                go_x(true);
            });
            $("#rgbbtn_wavedir_right").click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(this).addClass("active").siblings().removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("disable");

                go_x(false);
            });
            $("#rgbbtn_wavedir_up").click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(this).addClass("active").siblings().removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("disable");

                go_y(true);
            });
            $("#rgbbtn_wavedir_down").click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(this).addClass("active").siblings().removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("disable");

                go_y(false);
            });

            if (direct && typeof (direct) == "string") {
                $("#rgbbtn_wavedir_" + direct).trigger("click");
            }
        }
        function breathcolor() {

            var bg = $("#ef4-breathing");
            var btn = $("#rgbbtn_breathing");

            btn.click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("enable");

                changeColor();
                changecolorCB = changeColor;
            });

            function changeColor() {
                change("breathcolor");
                xi();
            }

            function xi() {
                var color = tinycolor(inp_color.val()).toHexString();
                bg.css({ backgroundColor: color });
                sto = setTimeout(tu, 2000);
            }
            function tu() {
                bg.css({ backgroundColor: "#4e4e4e" });
                sto = setTimeout(xi, 2000);
            }
        }

        function rain() {

            //var bg = $("#ef4-breathing");
            var btn = $("#rgbbtn_raindrop");
            var keys = $("#vkb .ag-keyboard-press");
            var lastColor;

            btn.click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("disable");

                keys.removeClass("on");
                change("raincolor");
                run();
            });

            function drop(n) {
                var t = keys.eq(n)
                var color;

                while (color = randomColor(), color == lastColor) { };

                t.addClass("on");
                t.css({ backgroundColor: color });

                lastColor = color;

                setTimeout(function () { t.removeClass("on") }, 400);
            }
            function run() {
                var n = random(0, keys.length);
                drop(n);

                sto = setTimeout(run, 10);
            }
        }
        function marquee() {

            var s = [27, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 19, 46, 36, 33, 34, 35, 109, 106, 111, 144, 8, 187, 189, 48, 57, 56, 55, 54, 53, 52, 51, 50, 49, 192, 9, 81, 87, 69, 82, 84, 89, 85, 73, 79, 80, 219, 221, 220, 103, 104, 105, 107, 102, 101, 100, "13:0", 222, 186, 76, 75, 74, 72, 71, 70, 68, 83, 65, 20, "16:0", 90, 88, 67, 86, 66, 78, 77, 188, 190, 191, "16:1", 38, 97, 98, 99, "13:1", 110, 96, 39, 40, 37, "17:1", 93, "18:1", 32, "18:0", 91, 94, "17:0"]
            //var bg = $("#ef4-breathing");  
            var elem = $("#ef2-marquee");
            var btn = $("#rgbbtn_marquee");
            var btn_single = $("#rgbbtn_marquee_single");
            var arr_list = [];
            var arr_color = [];
            var _singleColor;
            var _speed = 1000 / 10;

            btn.click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("disable");

                _singleColor = false;

                changeColor("marquee");
                changecolorCB = null;
            });

            btn_single.click(function () {
                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                btn_single.addClass("active");
                inp_color.spectrum("enable");

                _singleColor = true;

                changeColor("marquee_single");
                changecolorCB = null;
            });

            function press2(n, color) {
                var k = $("<div>");
                var i, ns;

                if (typeof n == "string") {
                    ns = n.split(':');
                    n = ns[0];
                    i = ns[1];
                } else {
                    i = 0;
                }
                var opt = cmap[n][i];

                k.addClass("ag-keyboard-press");
                k.css({ left: opt[0], top: opt[1], width: opt[2], height: opt[3], backgroundColor: color });
                k.appendTo(elem);

                setTimeout(function () { k.addClass("on") }, 0);
                setTimeout(function () {
                    //k.removeClass("on");
                    //setTimeout(function () { k.remove(); }, 400);
                }, 250);

                return n;
            }

            function dispose() {

                for (var i = 0; i < arr_list.length; i++) {
                    arr_list[i].remove();
                }

                arr_list = [];
                arr_color = [];
            }


            function render(n) {

                var color, i, k;

                if (_singleColor) {
                    color = tinycolor(inp_color.val()).toHexString();
                    k = arr_list[n];
                    k.css("backgroundColor", color);

                    setTimeout(function () { k.addClass("on") }, 0);
                    setTimeout(function () {
                        k.removeClass("on");
                        //setTimeout(function () { k.remove(); }, 400);
                    }, 250);
                } else {
                    while (color = randomColor(), (arr_color.length != 0 && (color == arr_color[0]))) { };

                    arr_color = [color].concat(arr_color).slice(0, s.length);

                    for (i = 0 ; i < arr_color.length; i++) {
                        arr_list[i].css("backgroundColor", arr_color[i]);
                    }
                }
            }

            function initKey() {
                var key,
                    i, n, ns, keyIndex, opt;

                for (i = 0; i < s.length; i++) {
                    n = s[i];
                    if (typeof n == "string") {
                        ns = n.split(':');
                        n = ns[0];
                        keyIndex = ns[1];
                    } else {
                        keyIndex = 0;
                    }

                    opt = cmap[n][keyIndex];
                    k = $("<div>");
                    k.addClass("ag-keyboard-press");
                    k.addClass("on");
                    k.css({ left: opt[0], top: opt[1], width: opt[2], height: opt[3] });
                    k.appendTo(elem);

                    arr_list.push(k);
                    //arr_list[s.length - 1 - i] = k;
                }
            }

            var i = 0;
            function changeColor(name) {

                if (change(name)) {
                    i = 0;
                    dispose();
                    initKey();
                };

                run();
            }
            function run() {

                render(i++);

                if (i == s.length) {
                    i = 0;

                    if (_singleColor) {
                        return sto = setTimeout(run, 1300);
                    }
                }


                return sto = setTimeout(run, _speed);
            }
        }
        function waveonkey() {

            var elem = $("#ef6-waveonkeypress");
            var btn = $("#rgbbtn_waveonkeypress");
            var color;

            function newwave(pos) {
                var left, right;
                var left1, left2;

                left = $('<div class="ef-img ef6-vcblock"><div class="ef6-block block1"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block2"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block3"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block4"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block5"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block6"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div></div>');
                right = $('<div class="ef-img ef6-vcblock right"><div class="ef6-block block1"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block2"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block3"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block4"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block5"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div><div class="ef6-block block6"><div class="ef6-block block-front"></div><div class="ef6-block block-back"></div></div></div>');

                left.find(".ef6-block").css("backgroundColor", color);
                right.find(".ef6-block").css("backgroundColor", color);
                //left = $('<div class="ef-img ef6-img">');
                //right = $('<div class="ef-img ef6-img right">');
                left1 = pos[0] - 120;
                left2 = pos[0] - 110;

                left.css({ left: left1 });
                right.css({ left: left2 });

                elem.append(left, right);

                sto = setTimeout(function () {
                    left.addClass("on").animate({ left: -391 }, (left1 + 391) * 2.5, "linear", function () { left.remove(); });
                    right.addClass("on").animate({ left: 1200 }, (1200 - left2) * 2.5, "linear", function () { right.remove(); });
                }, 16);
            }
            function changeColor() {
                color = tinycolor(inp_color.val()).toHexString();
            }
            btn.click(function () {

                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("enable");

                changeColor();
                change("waveonkey");
                changecolorCB = changeColor;
                _wok = true;
                run();
            });

            function run() {
                waveScript();
                //listenKey();
            }

            function waveScript() {
                newwave(cmap[Key.KeyList["]"]][0]);

                sto = setTimeout(function () {
                    newwave(cmap[Key.KeyList.C][0]);


                    sto = setTimeout(function () {
                        newwave(cmap[Key.KeyList.D][0]);

                        sto = setTimeout(run, 1500);
                    }, 400);
                }, 1000);
            }
            function listenKey() {
                window.addEventListener("keydown", function (e) {
                    var i = 0;
                    var k;
                    if (_wok) {
                        e.preventDefault();
                        k = e.keyCode;
                        if (((k == Key.KeyList.Alt ||
                             k == Key.KeyList.Ctrl ||
                             k == Key.KeyList.Win ||
                             k == Key.KeyList.WinNB ||
                             k == Key.KeyList.Shift) && e.location == 2) || (k == Key.KeyList.Enter && e.location == 3)) {
                            i = 1;
                        }

                        var pos = cmap[e.keyCode][i];
                        newwave(pos);
                    }
                }, false);
            }

        }



        function singlecolor() {

            var bg = $("#ef3-static");
            var btn = $("#rgbbtn_static");

            btn.click(function () {

                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                btn.addClass("active");
                inp_color.spectrum("enable");

                changeColor();
                changecolorCB = changeColor;
            });

            function changeColor() {
                var color = tinycolor(inp_color.val()).toHexString();
                bg.css({ backgroundColor: color });
                change("singlecolor");
            }
        }

        function gametype() {

            var elem = $("#ef7-gametype")
            var btn = $("#rgbbtn_gametype");
            var select = $("#select_gt");
            var index;
            var colorset = {
                group1: "#ffff00",
                group2: "#ff0000",
                group3: "#00ff00",
                group4: "#0790ff",
                group5: "#ffa500",
                group6: "#ff00ff"
            };
            var gt_table = [
                {
                    name: "CS:GO",
                    data: [{
                        color: colorset.group1,
                        list: ["1", "2", "3", "4", "5", "Q", "E", "R"]
                    }, {
                        color: colorset.group2,
                        list: ["Tab", "Y", "U", "K"]
                    }, {
                        color: colorset.group3,
                        list: ["W", "A", "S", "D"]
                    }, {
                        color: colorset.group4,
                        list: ["B"]
                    }, {
                        color: colorset.group5,
                        list: ["Shift:0", "Ctrl:0", "G"]
                    }]
                }, {
                    name: "Overwatch",
                    data: [{
                        color: colorset.group2,
                        list: ["V"]
                    }, {
                        color: colorset.group3,
                        list: ["R", "1", "2"]
                    }, {
                        color: colorset.group4,
                        list: ["W", "A", "S", "D", "Ctrl:0", "Space"]
                    }, {
                        color: colorset.group5,
                        list: ["Shift:0", "E"]
                    }]
                }, {
                    name: "League of Legends",
                    data: [{
                        color: colorset.group1,
                        list: ["1", "2", "3", "5", "6", "7"]
                    }, {
                        color: colorset.group2,
                        list: ["Q", "W", "E", "R"]
                    }, {
                        color: colorset.group3,
                        list: ["4", "D", "F"]
                    }, {
                        color: colorset.group4,
                        list: ["A"]
                    }, {
                        color: colorset.group5,
                        list: ["S", "B"]
                    }]
                }, {
                    name: "StarCraft II",
                    data: [{
                        color: colorset.group1,
                        list: ["F1", "F2", "F3", "F4"]
                    }, {
                        color: colorset.group2,
                        list: ["1", "2", "3", "4", "5"]
                    }, {
                        color: colorset.group3,
                        list: ["A", "S"]
                    }, {
                        color: colorset.group4,
                        list: ["Shift:0", "Ctrl:0", "Alt:0"]
                    }, {
                        color: colorset.group5,
                        list: ["B", "N"]
                    }, {
                        color: colorset.group6,
                        list: ["Enter:0"]
                    }]
                }, {
                    name: "FPS",
                    data: [{
                        color: colorset.group1,
                        list: ["1", "2", "3", "4"]
                    }, {
                        color: colorset.group2,
                        list: ["W", "A", "S", "D"]
                    }, {
                        color: colorset.group3,
                        list: ["R"]
                    }]
                }, {
                    name: "MMO",
                    data: [{
                        color: colorset.group1,
                        list: ["1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", "="]
                    }, {
                        color: colorset.group2,
                        list: ["W", "A", "S", "D"]
                    }, {
                        color: colorset.group3,
                        list: ["Enter:0"]
                    }]
                }, {
                    name: "MOBA",
                    data: [{
                        color: colorset.group1,
                        list: ["1", "2", "3", "4", "5"]
                    }, {
                        color: colorset.group2,
                        list: ["Q", "W", "E", "R"]
                    }, {
                        color: colorset.group3,
                        list: ["A"]
                    }, {
                        color: colorset.group4,
                        list: ["S", "B"]
                    }]
                }, {
                    name: "RTS",
                    data: [{
                        color: colorset.group1,
                        list: ["1", "2", "3", "4", "5"]
                    }, {
                        color: colorset.group2,
                        list: ["A", "S"]
                    }, {
                        color: colorset.group3,
                        list: ["Shift:0", "Ctrl:0", "Alt:0"]
                    }]
                }
            ];

            index = 0;
            btn.click(function () {
                set(index);
            });

            $.each(gt_table, function (i, setting) {

                var option = $("<option>");

                option.text(setting.name);
                option.val(i);
                select.append(option);

            });

            select.change(function () {
                set($(this).val());
            });

            function set(n) {

                $(".btn-rgbicon").removeClass("active");
                $(".btn-wavedir").removeClass("active");
                inp_color.spectrum("disable");

                btn.addClass("active");

                index = n;
                change("gametype");
                elem.html("");

                var setting = gt_table[n];
                var data;

                if (!setting) {
                    return;
                }

                data = setting.data;

                $.each(data, function (i, group) {

                    var color = group.color;
                    var list = group.list;
                    var j = 0;
                    var c;
                    var s;

                    for (; j < list.length; j++) {
                        s = list[j].split(":");
                        c = Key.KeyList[s[0]];
                        if (s[1]) {
                            c += ":" + s[1];
                        }
                        press(c, color);
                    }
                });
            }
            function changeColor() {

            }


            function press(n, color) {
                var k = $("<div>");
                var i, ns;

                if (typeof n == "string") {
                    ns = n.split(':');
                    n = ns[0];
                    i = ns[1];
                } else {
                    i = 0;
                }
                var opt = cmap[n][i];

                k.addClass("ag-keyboard-press");
                k.css({ left: opt[0], top: opt[1], width: opt[2], height: opt[3], backgroundColor: color });
                k.appendTo(elem);

                setTimeout(function () { k.addClass("on") }, 0);
            }
        }

        function random(min, max) {
            return Math.floor(Math.random() * (max - min + 1) + min);
        }

        function randomColor() {

            var r, g, b;

            r = random(0, 1) * 255;
            g = random(0, 1) * 255;
            b = random(0, 1) * 255;

            //去掉黑色
            if (!r && !g && !b) {
                return randomColor();
            }

            return "rgb(" + [r, g, b].join(",") + ")";
        }


        init();
    }
};