﻿(function (window) {                                                    
    var gstyle = window.Gstyle = {};
    var requestId = 0;

    var ytapi = {};

    var config = ytapi.config = {
        version: 'v3',
        root: "https://content.googleapis.com/youtube",
        "root-1p": "https://clients6.google.com",
        key: ""
    };

    ytapi.client = {
        request: function (options, callback) {

            var params, url, method;

            method = options.method || 'GET';
            params = options.params;
            params.key = config.key;

            url = options.path + '?' + mergeParams(params);

            getJSON(url, callback);
            //makerequest(method, url, null, callback);
        },
    };
    function mergeParams(obj) {
        var arr = [],
            c;
        for (var p in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, p)) {
                c = obj[p];
                arr.push(p + (c === '' ? '' : ('=' + encode(c))));
            }
        }
        return arr.join('&');
    }
    function encode(arg) {
        return window.encodeURIComponent(String(arg));
    }
    function makerequest(method, url, data, callback) {
        var xhr = newXHR();

        xhr.open(method, url);
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                callback.call(xhr, xhr.responseText);
            }
        };

        xhr.send(data = data || null);
    }
    ytapi.getPlaylistItem = function (playlistId, maxLength, callback) {
        var requestParams = {
            playlistId: playlistId,
            maxResults: maxLength,
            part: 'snippet,contentDetails',
        };
        var path = getPath('playlistItems');
        var callback = callback || function () { };

        var request = ytapi.client.request({
            method: 'Get',
            path: path,
            params: requestParams
        }, callback);
    };
    function getPath(resource) {
        var path = config['root'] + '/' + config['version'] + '/' + resource;
        return path;
    }
    function getJSON(url, callback) {
        var script = document.createElement('script');
        script.async = true;
        script.src = url + '&callback=Gstyle.c' + requestId;

        gstyle['c' + requestId] = (function (id) {
            return function (response) {
                delete gstyle['c' + id];
                script.parentNode.removeChild(script);

                callback(response);
            }
        })(requestId);

        ++requestId;

        document.head.appendChild(script);
    }
    function newXHR() {
        try {
            return new window.XMLHttpRequest
        } catch (a) { }
        try {
            return new window.ActiveXObject("Msxml2.XMLHTTP")
        } catch (a) { }
        return null;
    };

    window.ytapi = ytapi;
})(window);